Unit MouseX;
{$F+}
{ ------------------------------------------------------------------------- }
{                                                                           }
{ Minimal Microsoft Mouse Driver Interface Unit                             }
{                                                                           }
{ ------------------------------------------------------------------------- }

Interface

Uses Dos,SmModeX;

Type
  TMouseSubroutine = Procedure;

Const
  MouseInterrupt: Byte = $33;
  ClockInterrupt: Byte = $08;
  Save_DS       : Word = 0;
  _Save_DS      : Pointer = @Save_DS;
  MouseFore     : Packed Array[0..255] Of Byte =
  ( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15,15,15,15,15, 0, 0, 0, 0, 0, 0, 0,
    0,15,15,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15,15, 0,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,15, 0, 0, 0,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0,15,15, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0,15,15, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
  MouseMask     : Packed Array[0..255] Of Byte =
  ( 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
    0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1);

  ArrowMask : Array[0..31] Of Word =
  ($3FFF,$1FFF,$0FFF,$07FF,$03FF,$01FF,$00FF,$007F,$003F,$001F,$01FF,$10FF,$30FF,$F87F,$F87F,$FC7F,
   $0000,$4000,$6000,$7000,$7800,$7C00,$7E00,$7F00,$7F80,$7C00,$6C00,$4600,$0600,$0300,$0300,$0000);

  ClearMask : Array[0..31] Of Word =
  ($FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,
   $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000);

  BoxMask : Array[0..31] Of Word =
  ($00FF,$81FF,$81FF,$81FF,$81FF,$81FF,$81FF,$00FF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,
   $FF00,$FF00,$FF00,$FF00,$FF00,$FF00,$FF00,$FF00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000);

  MouseWidth  = 16;
  MouseHeight = 16;

Var
  MouseOn       : Boolean;
  MouseVisible  : Boolean;
  MScreenWidth  : LongInt;
  MScreenHeight : LongInt;
  BG            : Array[0..MouseWidth * MouseHeight - 1] Of Byte;
  UseModeX      : Boolean;
  WidthMul      : LongInt;
  HeightMul     : LongInt;

Procedure MouseInit(AWidth,AHeight,AWidthMul,AHeightMul: LongInt; AUseModeX: Boolean);
Procedure ToggleMouseVisibility;                { Toggles mouse cursor visible/hidden }
Procedure MouseReset;                           { Resets mouse driver, if active, to default state }
Function  GetMousePosition(Var MouseX,MouseY,MouseButtons: LongInt): Boolean;
Function  GetMouseMotion(Var XMotion,YMotion: Integer): Boolean;
Procedure MouseClose;
Procedure _MouseOn;
Procedure _MouseOff;
Procedure SetMouseCursor(Var Mask);
Function  SetInterruptSubroutine(Subroutine: TMouseSubroutine): Boolean;
Function  ClearInterruptSubroutine: Boolean;

Implementation

Uses VGAGUI;

Var
  X,Y,B       : LongInt;
  OldExitProc : Pointer;

Function GetMousePosition(Var MouseX,MouseY,MouseButtons: LongInt): Boolean;

{ ------------------------------------------------------------------------- }
{                                                                           }
{ Stores mouse coordinates and button state info in parameters if mouse     }
{ driver active                                                             }
{                                                                           }
{ Returns:        True if mouse driver is active                            }
{                 False if mouse driver is not active                       }
{                                                                           }
{ ------------------------------------------------------------------------- }

Var Regs : Registers;
Begin
  If Not MouseOn Then            { If mouse driver not active, return false }
  Begin
    GetMousePosition := False;
    Exit;
  End;
  Regs.AX := $0003;
  Intr(MouseInterrupt,Regs);
  MouseButtons     := Regs.BX;                   { Store mouse button state }
  MouseX           := Regs.CX Div WidthMul;      { Store mouse x coordinate }
  MouseY           := Regs.DX Div HeightMul;     { Store mouse y coordinate }
  GetMousePosition := True;
End; { GetMousePosition }


Procedure SaveMouseBackground;
Var X1,Y1: LongInt;
Begin
  Asm
    CLI
  End;
  X1 := MouseWidth;
  Y1 := MouseHeight;
  If X > MScreenWidth  - MouseWidth  Then X1 := MScreenWidth  - X;
  If Y > MScreenHeight - MouseHeight Then Y1 := MScreenHeight - Y;
  If (X1 > 0)           And (Y1 > 0)            And
     (X >= 0)           And (Y >= 0)            And
     (X < MScreenWidth) And (Y < MScreenHeight) Then GetImage(X,Y,X + X1 - 1,Y + Y1 - 1,BG);
  If UseModeX Then
  Begin
    Asm
      CLI
      MOV   DX,03CEh
      MOV   AX,4
      OUT   DX,AX
      MOV   DX,SC_INDEX
      MOV   AX,MAP_MASK
      OUT   DX,AX
    End; { Asm }
  End;
  Asm
    STI
  End; { Asm }
End; { SaveMouseBackground }


Procedure RestoreMouseBackground;
Var X1,Y1: LongInt;
Begin
  Asm
    CLI
  End;
  X1 := MouseWidth;
  Y1 := MouseHeight;
  If X > MScreenWidth  - MouseWidth  Then X1 := MScreenWidth  - X;
  If Y > MScreenHeight - MouseHeight Then Y1 := MScreenHeight - Y;
  If (X1 > 0)           And (Y1 > 0)            And
     (X >= 0)           And (Y >= 0)            And
     (X < MScreenWidth) And (Y < MScreenHeight) Then PutImage(X,Y,X1,Y1,BG);
  If UseModeX Then
  Begin
    Asm
      CLI
      MOV   DX,03CEh
      MOV   AX,4
      OUT   DX,AX
      MOV   DX,SC_INDEX
      MOV   AX,MAP_MASK
      OUT   DX,AX
    End; { Asm }
  End;
  Asm
    STI
  End; { Asm }
End; { RestoreMouseBackground }


Procedure DrawMouse;
Var X1,Y1: LongInt;
Begin
  Asm
    CLI
  End; { Asm }
  X1 := MouseWidth;
  Y1 := MouseHeight;
  If X > MScreenWidth  - MouseWidth  Then X1 := MScreenWidth  - X;
  If Y > MScreenHeight - MouseHeight Then Y1 := MScreenHeight - Y;
  If (X1 > 0)           And (Y1 > 0)            And
     (X >= 0)           And (Y >= 0)            And
     (X < MScreenWidth) And (Y < MScreenHeight) Then
  Begin
    PutMaskedImage(X,Y,MouseWidth,MouseHeight,X1,Y1,MouseFore,MouseMask);
  End;
  If UseModeX Then
  Begin
    Asm
      CLI
      MOV   DX,03CEh
      MOV   AX,4
      OUT   DX,AX
      MOV   DX,SC_INDEX
      MOV   AX,MAP_MASK
      OUT   DX,AX
    End; { Asm }
  End;
  Asm
    STI
  End; { Asm }
End; { DrawMouse }


Procedure ShowMouse;
Begin
  If (MScreenWidth <> 320) Or UseModeX Then
  Begin
    RestoreMouseBackground;
    GetMousePosition(X,Y,B);
    SaveMouseBackground;
    DrawMouse;
  End;
End; { ShowMouse }


Procedure Handler; Assembler;
Asm
  DD     0         { 4 bytes here - OldClockPtr }
  DW     0         { 2 bytes here - Save_DS     }

  CLI
  PUSHF
  PUSH   AX
  PUSH   BX
  PUSH   CX
  PUSH   DX
  PUSH   SI
  PUSH   DI
  PUSH   DS
  PUSH   ES
  PUSH   BP
  MOV    AX,WORD PTR Handler + 4
  MOV    DS,AX
  CMP    BYTE PTR MouseVisible,0
  JE     @L1
  CALL   ShowMouse
@L1:
  POP    BP
  POP    ES
  POP    DS
  POP    DI
  POP    SI
  POP    DX
  POP    CX
  POP    BX
  POP    AX
  POPF
  STI

  JMP    DWORD PTR Handler
End; { Handler }


Procedure MouseInit(AWidth,AHeight,AWidthMul,AHeightMul: LongInt; AUseModeX: Boolean);
Var
  Regs   : Registers;
  Vector : Pointer;
  OpCode : ^Byte;
  P      : ^Pointer;

Begin
  If Not MouseOn Then
  Begin
    MScreenWidth  := AWidth;
    MScreenHeight := AHeight;
    WidthMul      := AWidthMul;
    HeightMul     := AHeightMul;
    GetIntVec(MouseInterrupt,Vector);
    If Vector = Nil Then Exit;
    OpCode := Vector;                                { Mouse interrupt vector }
    If OpCode^ = $CF Then Exit;       { IRET opcode indicates no mouse driver }
    Regs.AX := 0;
    Intr(MouseInterrupt,Regs);
    If Regs.AX = $FFFF Then MouseOn := True; { -1 indicates mouse driver active }
    MouseVisible := False;
    Regs.AX := 7;                           { Set min/max horizontal position }
    Regs.CX := 0;
    Regs.DX := (MScreenWidth * WidthMul) - 1;
    Intr(MouseInterrupt,Regs);
    Regs.AX := 8;                             { Set min/max vertical position }
    Regs.CX := 0;
    Regs.DX := (MScreenHeight * HeightMul) - 1;
    Intr(MouseInterrupt,Regs);
    UseModeX := AUseModeX;
{    If (AWidth <> 320) Or AUseModeX Then
    Begin}
      P := @Handler;
      If P^ = Nil Then
      Begin
        P := @Handler;                           GetIntVec(ClockInterrupt,P^);
        P := Ptr(Seg(Handler),Ofs(Handler) + 6); SetIntVec(ClockInterrupt,P);
      End;
      GetMousePosition(X,Y,B);
{    End;}
  End;
End; { MouseInit }


Procedure MouseClose;
Var P: ^Pointer;
Begin
{  If (MScreenWidth <> 320) Or UseModeX Then
  Begin}
    P := @Handler;
    If P^ <> Nil Then SetIntVec(ClockInterrupt,P^);
    P^ := Nil;
{  End;}
  MouseOn := False;
End; { MouseClose }


Procedure ToggleMouseVisibility;
Var Regs: Registers;
Begin
  If MouseOn Then
  Begin
    If (MScreenWidth <> 320) Or UseModeX Then
    Begin
      If Not MouseVisible Then
      Begin
        Asm
          CLI
        End; { Asm }
        GetMousePosition(X,Y,B);
        SaveMouseBackground;
        MouseVisible := True;     { Track mouse visible/hidden state }
        Asm
          STI
        End; { Asm }
      End
      Else
      Begin
        Asm
          CLI
        End; { Asm }
        MouseVisible := False;    { Track mouse visible/hidden state }
        RestoreMouseBackground;
        Asm
          STI
        End; { Asm }
      End;
    End
    Else
    Begin
      If MouseVisible
       Then Regs.AX := $0002
       Else Regs.AX := $0001;
      Intr(MouseInterrupt,Regs);
      MouseVisible := Not MouseVisible;    { Track mouse visible/hidden state }
    End;
  End;
End; { ToggleMouseVisibility }


Procedure MouseReset;
Begin
  If MouseVisible Then ToggleMouseVisibility;
{  MouseInit;}
End; { MouseReset }


Procedure _MouseOn;
Begin
  If Not MouseVisible Then ToggleMouseVisibility;
End; { _MouseOn }


Procedure _MouseOff;
Begin
  If MouseVisible Then ToggleMouseVisibility;
End; { _MouseOff }


Procedure SetMouseCursor(Var Mask);
Var Regs: Registers;
Begin
  Regs.AX := 9;                           { Set graphics cursor }
  Regs.BX := 0;
  Regs.CX := 0;
  Regs.DX := Ofs(Mask);
  Regs.ES := Seg(Mask);
  Intr(MouseInterrupt,Regs);
End; { SetMouseCursor }


Function GetMouseMotion(Var XMotion,YMotion: Integer): Boolean;
{ ------------------------------------------------------------------------- }
{                                                                           }
{ Stores mouse motions values in parameters if mouse driver active          }
{                                                                           }
{ Returns:        True if mouse driver is active                            }
{                 False if mouse driver is not active                       }
{                                                                           }
{ ------------------------------------------------------------------------- }
Var Regs: Registers;
Begin
  If MouseOn Then   { If mouse driver not active, return false }
  Begin
    Regs.AX := $000B;
    Intr(MouseInterrupt,Regs);
    XMotion := Regs.CX;                   { Store mouse x coordinate }
    YMotion := Regs.DX;                   { Store mouse y coordinate }
    GetMouseMotion := True;
  End
  Else GetMouseMotion := False;
End; { GetMouseMotion }

Function SetInterruptSubroutine(Subroutine: TMouseSubroutine): Boolean;
Var Regs: Registers;
Begin
  If MouseOn Then
  Begin
    Regs.AX := $000C;
    Regs.CX := $FFFF;
    Regs.DX := Seg(Subroutine);
    Regs.ES := Ofs(Subroutine);
    Intr(MouseInterrupt,Regs);
    SetInterruptSubroutine := True;
  End
  Else SetInterruptSubroutine := False;
End; { SetInterruptSubroutine }

Function ClearInterruptSubroutine: Boolean;
Var Regs: Registers;
Begin
  If MouseOn Then
  Begin
    Regs.AX := $000C;
    Regs.CX := 0;
    Regs.DX := 0;
    Regs.ES := 0;
    Intr(MouseInterrupt,Regs);
    ClearInterruptSubroutine := True;
  End
  Else ClearInterruptSubroutine := False;
End; { ClearInterruptSubroutine }

Procedure NewExitProc; Far;
Begin
  ExitProc := OldExitProc;
  _MouseOff;
  MouseClose;
End; { NewExitProc }

Begin
  MScreenWidth  := 320;
  MScreenHeight := 200;
  UseModeX     := False;
  MouseOn      := False;
  MouseVisible := False;
  WidthMul     := 2;
  HeightMul    := 1;
  Word(Ptr(Seg(Handler),Ofs(Handler) + 4)^) := DSeg;
  OldExitProc := ExitProc;
  ExitProc    := @NewExitProc;
End.
